﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.8
@EndOfDesignText@
' ========================================================
' Description ...: Form Generator for B4J
' Requirement(s).: B4J 6.51
' Author ........: Giovanni Rossati (El Condor)
' Version........: 0.7.0
' Date...........: 18 April 2023
' License........: Free to use without any warranties
' ========================================================
'Class module
Sub Class_Globals
	Public version As String = "0.7.0 18 April 2023"
	Public colorsMap As Map = CreateMap("red":fx.Colors.red,"green":fx.Colors.green,"blue":fx.Colors.blue, "magenta":fx.Colors.Magenta, _
							"yellow":fx.Colors.Yellow,"gray":fx.Colors.Gray,"lightgray":fx.Colors.LightGray,"cyan":fx.Colors.Cyan, _
							"black":fx.Colors.Black,"white":fx.Colors.White)
	Private fx As JFX
	Private nativeMe As JavaObject
	Dim fh_Data As Map = CreateMap()		' Reference to node of data
	Private fh_FieldsType As Map = CreateMap()	' Reference to fields type
	Private numericTypes As Map = CreateMap("N":True,"DN":True,"S":True)	' nodes with numeric values
	Dim comparator As Map = CreateMap("eq":1,"gt":2,"lt":4,"ge":3,"le":5,"ne":6,"<=":5,"<>":6,">=":3,"=":1,">":2,"<":4)
	Dim defLength As Map = CreateMap("A":50,"S":6,"QS":10,"F":30,"DN":11,"N":9,"P":20,"R":12,"D":30,"F":30,"WF":30,"DATE":18,"TIME":8,"C":"","B":70)
	Dim nodeSynonims As Map = CreateMap("BACKGROUND":"FORM","GROUND":"FORM","COMMENT":"C","RDB":"R","FILE":"F","WFILE":"WF", _
										"HIDDEN":"H","DEFAULTS":"DEFAULT","RDEFAULTS":"RDEFAULT","TOGGLE":"TB")
	Dim fh_yesToExit As Boolean = True	' used for block exit
	Private fh_module As Object		' calling Module
	Private fh_returnSub As String	' receiving sub
	Private fh_handleSub As String	' handle events sub
	Private fh_ground As Pane		' Reference to container panel
	Private fh_panel As Pane		' Reference to panel handle
	Private widgetRef As Map		' Reference to node of data
	Private Elem As Map				' data fields
	Private Defaults As Map			' fields defaults
	Dim Dictionary As Map = CreateMap()	' possibly dictionary
	Private checks As Map			' checks on nodes, key is field name
	Private required As Map			' required nodes, key is field name
	Private after As Map			' after key is Node to set after value
	Private menuList As List		' menu
	Private Limits As Map			' for numerics fields
	Private mapValues As Map		' combo/radio key value
	Dim mapFontLabel As Map
	Dim mapFontTitle As Map
	Dim title As String = "FormGen"
	Private lblTitle As Label
	Private hasTitle As Boolean
	Dim replaceMap As Map = CreateMap(44:"#44",59:"#59",39:"#39",34:"#34",10:"#10")	' for mask function
	Private hiddensMap As Map	' Hiddens values
	Private fhSubstMap As Map = CreateMap()		' elements within ' or ""
	Private field() As String
	Private pnl As Pane
	Private lbl As Label
	Dim okTypes As String = "--T-N-NS-NF-P-A-F-S-QS-CKB-CKL-CMT-CMX-DATE-R-TB-TIME-"
	Dim lonely As Int			' 0 no widget, 1 only one CMB or Radio, > 1 widgets
	Dim allButtons As Map
	Dim customOkButton As Boolean ' true Ok button isn't generate
	Dim isWindow As Boolean = False	' if window the form is on main form
	Dim window() As Object			' window pseudo
' ********** properties **********
	Dim titlefont As String = "bold 20 sans-serif"
	Dim btnWidth As Int = 70
	Dim btnHeight As Int = 30
	Dim textWidth As Int = 60		' for multi line
	Dim charWidth As Float = 7.06	' font 12
	Dim offsetX As Int = 5
'	Dim offsetY As Int = 40
	Dim fh_isRunning As Boolean
	Dim stylesheet As String		' 
' ********** properties **********
	Private Matcher1 As Matcher
	Private Sections(1,3) As String		' sections array
	Private Section As Int = -1			' actual section
	Private IsUpdatingText As Boolean = False
	Dim frm As Form
	Private lineHeight As Int  = 17				' 17 (fontsize = 12)
	Private reDeMask As String = "#\d+|#[xX][aAbBcCdDeEfF\d]+" 'one or more digits
	Private reMail As String = "^[a-zA-Z0-9._+-]+@[a-zA-Z0-9-]+\.[a-zA-Z]{2,4}+$|^$"
	Private reHexaDecimal As String = "^[\daAbBcCdDeEfF]{1,8}$"
	Private labels() As Object
	Private reOperands As String
End Sub
Public Sub Initialize()
	nativeMe = Me
	colorsMap.Put("teal",fx.Colors.RGB(0,127,127))
	colorsMap.Put("olive",fx.Colors.RGB(127,127,0))
	colorsMap.Put("aqua",fx.Colors.RGB(0,255,255))
	colorsMap.Put("orange",fx.Colors.RGB(255,165,0))
	colorsMap.Put("silver",fx.Colors.RGB(192,192,192))
	colorsMap.Put("crimson",fx.Colors.RGB(220,20,60))
	colorsMap.Put("purple",fx.Colors.RGB(128,0,128))
'	Dim kOp As List
'	kOp.Initialize
'	For Each k As String In comparator.Keys
'		kOp.Add(k)
'	Next
	Dim aOperators() As String = Array As String  (" eq "," gt "," lt "," ge "," le "," ne ","<=","<>",">=","=",">","<")
	reOperands = "(.+?)\s*( is |" & implode("|",aOperators) & ")\s*(.*)"	' generate a regular expression for check operators
	defLength.Put("B",btnWidth)
'	labels = Array("","CENTER_LEFT","")
End Sub
Sub fgw(params As String,Module As Object,handleSub As String)	' for handle data in the same calling sub
	fg(params,Module,"",handleSub)
End Sub
Sub fg(params As String,Module As Object,retSub As String,handleSub As String)
	fh_isRunning = True
	fh_returnSub = retSub
	fh_handleSub = handleSub
	fh_module = Module
	params = Regex.Replace2(";'|^'",Regex.MULTILINE,";" & params, ";#")
	' ' and " "
	params = quoteMask(params)
	stylesheet = ""
	Dim MatchSection As Matcher = Regex.Matcher2("(.*?);(Section.*)",Regex.CASE_INSENSITIVE,params)	' items before first section	' '' and ""
	params = quoteMask(params)
	Dim MatchSection As Matcher = Regex.Matcher2("(.*?);(Section.*)",Regex.CASE_INSENSITIVE,params.Replace(Chr(10),""))	' items before first section
	Dim beforeSection As String = ""
	Dim s As List
	s.initialize
	If MatchSection.Find Then
		beforeSection = MatchSection.Group(1) & ";"
		params = MatchSection.Group(2)
		s.AddAll(Regex.split2("^section.*?;|;section.*?;",Regex.CASE_INSENSITIVE,params))
		s.RemoveAt(0)
		Dim Sections(s.size,3) As String	' section widgets, Section name, check condition(s)
		Dim Matcher2 As Matcher = Regex.Matcher2(";(section.*?);",Regex.CASE_INSENSITIVE, ";" & params)
		Dim i As Int = 0
		Dim sectionTitle As String = ""
		Do While Matcher2.Find
			Sections(i,1) = ""
			Sections(i,2) = ""
			Dim sect() As String = Regex.Split(",",Matcher2.Group(1))
			If sect.Length > 2 Then
				Sections(i,2) = implodeFrom(",",sect,2,sect.Length-1)	' check conditions
			End If
			If sect.Length > 1 Then
				sectionTitle = ";Title,fh_section" & (i+1) & "," & sect(1) & ";"
			End If
			Sections(i,0) = beforeSection & sectionTitle & s.Get(i)	' parameters
			i = i + 1
		Loop
	Else
		Dim Sections(1,3) As String
		Sections(0,0) = params
	End If
	Section = 0
	fgSection(Sections(0,0),Null)
End Sub
Sub cleanForm
	If isWindow Then
		fh_ground.RemoveNodeFromParent
	Else
		frm.Close
	End If
	fh_isRunning = False
End Sub
Sub fgSection(params As String,data As Map)
	If Not(data.IsInitialized) Then
		fh_Data.Initialize
		fh_FieldsType.Initialize
	End If
	isWindow = False
	allButtons.Initialize
	widgetRef.Initialize
	Elem.Initialize
	checks.Initialize
	required.Initialize
	Limits.Initialize
	mapValues.Initialize
	Defaults.Initialize
	hiddensMap.Initialize
	menuList.Initialize
	after.initialize
	customOkButton = False
	mapFontLabel = setTipefaces("12 left ")
	mapFontTitle = setTipefaces("20 center ")
	labels = Array("","CENTER_LEFT","")
	hasTitle = False
	Dim widgets() As String
	Dim width, deltaY,offsetTop,labelWidth As Int
	Dim wdgType As String
	Dim fromTo() As String	' array for split ground colors and defaults
	width = 50	' width ?
	deltaY = 2 * lineHeight
'	offsetTop = offsetY
	widgets = Regex.Split(";\s*", "Form;" & params)	' for default
	fh_panel.Initialize("")
	fh_panel.Tag = "fh_panel"
	Dim dimLabels As Int = 0
	lbl.Initialize("")
	lbl.style = "-fx-background-color: transparent;-fx-text-fill: silver;"
	CSSUtils.SetStyleProperty(lbl, "-fx-font", "bold 12 serif")	' font family must be present
	' normalize request: control and clean parameters
	For iw = 0 To widgets.Length - 1
		If Left(widgets(iw),1) = "#" Or widgets(iw) = "" Then Continue	' comment
		field = Regex.Split(",", widgets(iw).Trim & ",,,,,,*")
		field(field.Length-1) = ""	' remove *
		field(0) = field(0).ToUpperCase	' upper case
		field(0) = nodeSynonims.GetDefault(field(0),field(0))		
		Select field(0)
			Case "TITLE" 	' title
				hasTitle = True
				mapFontTitle = setTipefaces("20 center " & field(3))
				lblTitle.Initialize("")
				lblTitle.text = translate(deMask(field(2)))
				title = lblTitle.text
				lblTitle.Font = mapFontTitle.Get("Typeface")
				CSSUtils.SetBackgroundColor(lblTitle, decodeColor(field(4)))
				lblTitle.Alignment = mapFontTitle.Get("Gravity")
				lblTitle.TextColor = mapFontTitle.Get("TextColor")
				If field(1).Trim = "" Then field(1) = "fh_title"
				lblTitle.Tag = field(1)
				fh_FieldsType.Put(field(1),field(0))
				widgetRef.Put(lblTitle.tag,Array As Object (lblTitle,"TITLE",0,"","",0))	' length is add before form show
			Case "DEFAULT" 		' defaults Node
				For ir=1 To field.Length - 1
					If field(ir) = "" Then Continue
					fromTo = Regex.Split(":",field(ir))	' create a 2 item array
					If fromTo.Length = 2 Then Defaults.Put(fromTo(0),deMask(fromTo(1)))
				Next
			Case "RDEFAULT" 		' random defaults Node
				For ir=1 To field.Length - 1
					If field(ir) = "" Then Continue
					fromTo = Regex.Split(":",field(ir))	' create a 2 item array
					If fromTo.Length = 1 Then ' can be combo or rdb
						Dim f() As String = Elem.GetDefault(field(ir),Array As String("","","","","",""))	' if no defaults, take item list
						Dim rString() As String = Regex.Split("\|",Regex.Replace("\|.*?:","|" & f(5),"|"))
						Dim rndx As Int = IIf(rString.Length > 1,Rnd(1,rString.Length),0)
						Defaults.Put(fromTo(0),deMask(rString(rndx)))
					Else
						Dim re As String = "^\s*([-+]?\d+)\s+([-+]?\d+)\s*$"	' for caputure n1 n2 (ex -100 100)						
						Dim Match As Matcher = Regex.Matcher(re, fromTo(1))
						If Match.Find Then
							Defaults.Put(fromTo(0),Rnd(Match.Group(1),Match.Group(2) + 1))
						Else
							Defaults.Put(fromTo(0),fromTo(1))								
						End If							
					End If
				Next
			Case "REQUIRED" 							' required Node
				For ir=1 To field.Length - 1
					required.Put(field(ir),"")
				Next
			Case "H" 			' Hiddens fields
				If field(2).ToLowerCase = "%now" Then field(2) = DateTime.Date(SetDate(field(2),""))
'				hiddensMap.Put(field(1),implodeFrom(",", field,2,100))
				hiddensMap.Put(field(1),deMask(field(2)))
				widgetRef.Put(field(1),Array As Object (0,"H",0,"","",0))
			Case "CHECK"		' checks on fields
				Matcher1 = Regex.Matcher2(reOperands,Regex.CASE_INSENSITIVE,deMask(field(1)))
				If Matcher1.Find Then
					addCheck(Matcher1.Group(1),Array As String(deMask(field(1)),field(2)))		' check and possible error message
				End If
			Case "AFTER" 		' after
				If fh_FieldsType.ContainsKey(field(1)) And fh_FieldsType.ContainsKey(field(2)) Then
					after.Put(field(1),field(2))
				Else
					field(0) = "C"				
					If Not(fh_FieldsType.ContainsKey(field(1))) Then
						field(2) = field(1) & " not exists! After ignored"
					Else
						field(2) = field(2) & " not exists! After ignored"					
					End If
					field(3) = field(2).length*charWidth
					field(1) = ""
					Elem.Put(field(1),field)
				End If
			Case "DICT"
				Dictionary = CallSub2(fh_module,field(1),field(2))
			Case "FORM", "WINDOW"	' Background 	ex linear-gradient(to bottom right, red, black)
				setBackground(field,fh_panel)
				If field(0) = "WINDOW" Then
					isWindow = True
				End If
				stylesheet = extractParm("style",field(2))
				window = field
			Case "MENU" 		' Menu
				menuList.Add(implodeFrom(",",field,1,3))
			Case "LABEL"
				labels(2) = field(3)	' text after label
				mapFontLabel = setTipefaces("12 left black " & field(2))
			Case Else
				If field(1) = "" Then field(1) = "fh_" & iw	' if no field name
				field(4) = deMask(field(4).Trim())	' default
				field(5) = deMask(field(5))			' extra
				If field(3) = "" Then
					If defLength.ContainsKey(field(0)) Then
						field(3) = defLength.get(field(0))
					Else
						field(3) = Max(25,field(4).Length)	' length widget
					End If
				End If
				If field(0) = "" Then field(0) = "T" 	' default or unknown set to text
				If field(0) = "T" And field(3) > textWidth Then field(0) = "A"	' this is a textarea
				If field(0) = "TB" And field(5) = "" Then field(5) = "On|Off"
				If field(0) <> "C" Then
					If field(2) = "" Then field(2) = normalizeLabel(field(1))	' if there is not label
					field(2) = deMask(field(2))			' label
					If field(0) <> "B" And field(0) <> "IB" And field(0) <> "TB" Then
						labelWidth = getLabelWidth(translate(field(2)) & labels(2),mapFontLabel.Get("TextSize"))
						If labelWidth > dimLabels Then dimLabels = labelWidth
					End If
					If Not(Defaults.ContainsKey(field(1))) Then
						Defaults.Put(field(1),field(4))	' set defaults map
					End If
				Else
					field(2) = deMask(field(2))
					If Not(Defaults.ContainsKey(field(1))) Then Defaults.Put(field(1),field(2))	' set defaults map
				End If
				Elem.Put(field(1),field)
				fh_FieldsType.Put(field(1),field(0))	' for type numeric or string			
		End Select
	Next
	dimLabels = dimLabels + 16	' padding
	lonely = 0				' for type of final buttons
	' create form -------------------------------------------------------------------------------------
	offsetTop = 5
	If hasTitle Then
		Dim titleHeight As Int = getHeight(1) * mapFontTitle.Get("TextSize") / 12
		Dim titletWidth As Int = lblTitle.text.Length*charWidth * mapFontTitle.Get("TextSize") / 12
		offsetTop = titleHeight + 3
		setInMap(lblTitle.tag,5,titletWidth)
	End If
	For Each node In Elem.Keys
		field = Elem.Get(node)
		Dim lblx As Label = CopyObject(lbl)
		lblx.Initialize("")
		lblx.text = translate(field(2)) & IIf(field(2).Trim <> "",labels(2),"")
		lblx.TextColor = mapFontLabel.Get("TextColor")
		lblx.Font = mapFontLabel.Get("Typeface")
		CSSUtils.SetStyleProperty(lblx,"-fx-padding","3")
		lblx.Alignment = mapFontLabel.Get("Gravity")
		wdgType = field(0)
		Dim txtProto As TextField
		If okTypes.indexOf("-" & wdgType & "-") > 0 Then
			lonely = lonely + 2	' resettable fields
		End If
		If wdgType = "B" Or wdgType = "IB" Or wdgType = "TB" Then
			If Defaults.GetDefault(field(1),"") <> "" Then
				lonely = lonely + 2	' button resettables
			Else
				lonely = lonely + 97	' prime number
			End If
		End If
		If wdgType = "CMB" Then lonely = lonely + 1
		If wdgType = "B" Then			
			If field(1) = "Cancel" Or field(1) = "Reset" Then
				allButtons.Put(field(1),Array As Object (field(2),field(1),"",0,field(3),field(5)))
'				Dim event As String = field(1)
			End If
			If after.ContainsKey(field(1)) Then
				If fh_FieldsType.get(after.Get(field(1))) = "TITLE" Then
					setInMap(after.Get(field(1)),3,field(1))
					Continue	' the button is inserted after title before to show the form
				End If
				Dim btn As Button = CreateButton(field(1),field(2),IIf(field(1) = "Cancel","Cancel","afterButtons"),"B")
				btn.Tag = field(1)
				Dim afterNode As Node = getFromNodeMap(after.Get(field(1)),0)			 
				fh_panel.AddNode(btn,afterNode.Left+afterNode.PrefWidth+5,afterNode.Top,field(3),btnHeight)
				setInMap(field(1),5,afterNode.Left+afterNode.PrefWidth+5+field(3))	' right position
			Else
				If Not("CancelReset".Contains(field(1))) Then
					If field(5) = "" Then customOkButton = True
					allButtons.Put(field(1),Array As Object (field(2),"Buttons",field(5),0,field(3),""))
				End If
			End If
		Else If wdgType = "IB" Then		' in line button
			Dim aLbl() As String = Regex.Split(":",field(2) & ":*")
			Dim inLineBtn As Button = CreateButton(field(1),aLbl(0),"IButtons",wdgType)
			If isGraphicFile(aLbl(0)) Then
				Dim wh() As String = Regex.Split("x",inLineBtn.Tag)
				fh_panel.AddNode(inLineBtn,offsetX, offsetTop,wh(0),wh(1))
			Else
				fh_panel.AddNode(inLineBtn,offsetX, offsetTop, field(3), btnHeight)
			End If
			inLineBtn.Tag = field(1)	' (create button with graphic returns WxH)
			If aLbl(1) = "*" Then aLbl(1) = normalizeLabel(field(1))
			Dim lblIB As Label = Createlabel(aLbl(1),mapFontLabel.Get("TextSize"),"")
			lblIB.TextColor = mapFontLabel.Get("TextColor")	' it is also in mapFontLabel.Get("TextColor")
			lblIB.Font = mapFontLabel.Get("Typeface")
			lblIB.Tag = field(1)	' fieldName
			Dim labLength As Int = getLabelWidth(aLbl(1),mapFontLabel.Get("TextSize"))
			fh_panel.AddNode(lblIB,offsetX+field(3)+10, offsetTop, labLength+10, deltaY)
			setInMap(field(1),5,lblIB.Left + labLength+10)
		Else If wdgType = "TB" Then		' in line toggle button
			Dim TBList As List = splitKeyValue(field(1),field(5))
			If Defaults.getDefault(field(1),"") == "" Then Defaults.Put(field(1),mapValues.Get(field(1) & TBList.get(0)))	' set defaults map
			Dim inLineBtn As Button = CreateButton(field(1),TBList.get(0),"IButtons",wdgType)
			fh_panel.AddNode(inLineBtn,offsetX, offsetTop, field(3), btnHeight)
			Dim lblIB As Label = Createlabel(field(2),mapFontLabel.Get("TextSize"),"")
			lblIB.TextColor = mapFontLabel.Get("TextColor")	' it is also in mapFontLabel.Get("TextColor")
			lblIB.Font = mapFontLabel.Get("Typeface")
			lblIB.Tag = field(1)	' fieldName
			Dim labLength As Int = getLabelWidth(field(2),mapFontLabel.get("TextSize"))
			fh_panel.AddNode(lblIB,offsetX+field(3)+10, offsetTop, labLength+10, deltaY)
			widgetRef.Put(field(1),Array As Object (inLineBtn,"TB",0,TBList,"",labLength+10))
		Else If wdgType = "CKB" Then
			Dim ckbProto As CheckBox
			ckbProto.Initialize("checkBox")
			ckbProto.TextColor = mapFontLabel.Get("TextColor")
			ckbProto.text = " " & translate(field(5))			
			ckbProto.Font = mapFontLabel.Get("Typeface")
			ckbProto.Tag = field(1)
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				Dim afterNode As Node = getFromNodeMap(after.Get(field(1)),0)
				fh_panel.AddNode(ckbProto,afterNode.Left+afterNode.PrefWidth+10, afterNode.Top , field(3) * charWidth, deltaY)
			Else
				fh_panel.AddNode(ckbProto ,offsetX + dimLabels,  offsetTop-5, field(3) * charWidth, deltaY-2)
			End If
			widgetRef.Put(field(1),Array As Object (ckbProto,wdgType,lblx,"","",ckbProto.Left+field(3) * charWidth))
		Else If wdgType = "CKL" Then			
			Dim ckList As List = splitKeyValue(field(1),field(5))
			widgetRef.Put(field(1),Array As Object (0,"CKL",0,ckList,"",0))
			For j = 0 To ckList.Size-1
				Dim ckbProto As CheckBox
				ckbProto.Initialize("checkBox")
				ckbProto.TextSize = 12
				ckbProto.text = " " & ckList.get(j)
				ckbProto.TextColor = mapFontLabel.Get("TextColor")
				Dim name As String = mapValues.get(field(1) & ckList.get(j))
				ckbProto.Tag = name
				fh_panel.Addnode(ckbProto,offsetX + dimLabels, offsetTop+(deltaY-5)*j, field(3) * charWidth,deltaY-2)
				widgetRef.Put(name,Array As Object (ckbProto,"CKB",lbl,field(1),"",ckbProto.Left+field(3) * charWidth))
				If field(4) = name Then Defaults.Put(name,"1")
				If Not(Defaults.ContainsKey(name)) Then Defaults.Put(name,"")	' set defaults map
				fh_FieldsType.Put(name,"CKB")
			Next
		Else If wdgType = "R" Then			' *** Radiobuttons
			Dim rdbList As List = splitKeyValue(field(1),field(5))
			Dim rdbGroup(rdbList.size) As RadioButton
			pnl.Initialize("")
			For j = 0 To rdbList.Size-1
				rdbGroup(j).Initialize("RadioButton")
				rdbGroup(j).TextSize = 12
				rdbGroup(j).text = translate(rdbList.get(j))
				rdbGroup(j).TextColor = mapFontLabel.Get("TextColor")
				rdbGroup(j).Font = mapFontLabel.Get("Typeface")
				rdbGroup(j).Tag = field(1)
				pnl.AddNode(rdbGroup(j),j*field(3) * charWidth,0,field(3) * charWidth, deltaY-2)
				rdbList.set(j, rdbGroup(j))
			Next
			rdbGroup(0).GroupRadioButtons(rdbList)
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				Dim afterNode As Node = getFromNodeMap(after.Get(field(1)),0)
				fh_panel.AddNode(pnl,afterNode.Left + afterNode.PrefWidth + 10, afterNode.Top-5 , field(3) * charWidth, deltaY-2)
			Else
				fh_panel.AddNode(pnl,offsetX + dimLabels, offsetTop-5 , field(3) * charWidth, deltaY-2)
			End If
			widgetRef.Put(field(1),Array As Object (pnl,wdgType,lblx,Null,"",pnl.left+j*field(3) * charWidth))
		Else If wdgType = "CMB" Or wdgType = "CMX"  Or wdgType = "CMT" Then	' *** ComboBox
			Dim event As String = IIf(wdgType = "CMX","comboCMX","combos")
			Dim cmb As ComboBox
			cmb.Initialize(event) 'All combos share the same event sub
			Dim yText As Int = offsetTop
			If wdgType = "CMT" Then cmb.Editable = True
			Dim cmbWidth As Int = IIf(wdgType = "CMX",Min(field(3),textWidth),field(3))		
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				Dim afterNode As Node = getFromNodeMap(after.Get(field(1)),0)
				Dim nodeLeft As Int = afterNode.Left + afterNode.PrefWidth + 10
				Dim labelLength As Int = (field(2) & labels(2)).length*charWidth
				fh_panel.AddNode(lblx,nodeLeft, afterNode.Top, labelLength, deltaY-10)
				fh_panel.AddNode(cmb,nodeLeft + labelLength + 2, afterNode.Top, cmbWidth * charWidth, deltaY-10)
			Else
				fh_panel.AddNode(cmb,offsetX + dimLabels, offsetTop, cmbWidth * charWidth, deltaY-10)
			End If
			If wdgType = "CMX" Then yText = offsetTop+deltaY
			cmb.Tag = field(1)
			cmb.Items.AddAll(splitKeyValue(field(1),field(5)))
			CSSUtils.SetStyleProperty(cmb, "-fx-padding","2")
			cmb.TooltipText = field(2)	' the label is prompt
			widgetRef.Put(field(1),Array As Object (cmb,wdgType,lblx,cmb,"",cmb.Left+cmbWidth * charWidth))
			If wdgType = "CMX" Then		' combo + text added				
				Dim txtArea As TextArea = setTextArea(field)
				widgetRef.Put(field(1),Array As Object (txtArea,wdgType,lblx,cmb,"",cmb.Left+cmbWidth * charWidth))
				fh_panel.AddNode(txtArea,offsetX + dimLabels,  yText, cmbWidth * charWidth, getHeight(Ceil(field(3)/textWidth)))
				Dim l As Label = setEraser(field)
				Dim leftEraser As Int = - 16 + txtArea.Left + cmbWidth * charWidth
				fh_panel.AddNode(l,leftEraser, yText, 25, 25)
			End If
		Else If wdgType = "F"  Or wdgType = "WF" Or wdgType = "D" Then			
			txtProto = setText(field)
			fh_panel.AddNode(txtProto,offsetX + dimLabels , offsetTop, field(3) * charWidth,  getHeight(Ceil(field(3)/textWidth)))
			Dim btnx As Button = addButton("...","File",offsetX+10 + dimLabels+field(3) * charWidth,offsetTop-2)
			widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lblx,"","",btnx.Left+5*charWidth))
			btnx.MouseCursor = fx.Cursors.HAND
			If field(5) <> "" Then txtProto.PromptText = field(5)
			btnx.Tag = field(1)		' name
		Else If wdgType = "U" Or wdgType = "UN" Then
			txtProto = setText(field)
			Dim uLbl As Label
			uLbl.Initialize("")
			uLbl.text = translate(field(4))
			uLbl.TextColor = mapFontLabel.Get("TextColor")
			uLbl.Font = mapFontLabel.Get("Typeface")
			If wdgType = "UN" Then' numerics fields
				CSSUtils.SetStyleProperty(txtProto, "-fx-alignment", "CENTER-RIGHT")
			End If
			widgetRef.Put(field(1),Array As Object (uLbl,wdgType,lblx,"","",uLbl.Left+field(3) * charWidth))
			fh_panel.AddNode(uLbl,offsetX + dimLabels, offsetTop, field(3) * charWidth, getHeight(Ceil(field(3)/textWidth)))
		else If wdgType = "C" Then 	' comment
			Dim mapFontComment As Map = setTipefaces(field(5))
			Dim scrollComment As ScrollPane
			Dim comment As Label
			comment.Initialize("")
			comment.Text = field(2)
			comment.TextColor = mapFontComment.Get("TextColor")
			comment.TextSize =  mapFontComment.Get("TextSize")
			comment.wraptext = True
			Dim nLL() As Int = commentDimension(comment.Text,comment.TextSize)	' returns lines, max line width
			If IsNumber(field(3)) Then	' width
				nLL(0) = nLL(0) * Ceil(nLL(1)/field(3))
				Dim commentWidth As Int = field(3)
			Else
				Dim commentWidth As Int = nLL(1) + 10	' for padding
				field(3) = commentWidth
			End If
'			CSSUtils.SetStyleProperty(comment, "-fx-background-color","cyan")
			Dim commentHeight As Int = getHeight(nLL(0)) * mapFontComment.Get("TextSize") / 12
			CSSUtils.SetStyleProperty(comment,"-fx-alignment",mapFontComment.Get("Gravity"))
			widgetRef.Put(field(1),Array As Object (comment,wdgType,0,"","",comment.Left+commentWidth))
			If Not(IsNumber(field(4)))	Then
				fh_panel.AddNode(comment,offsetX, offsetTop, commentWidth,commentHeight )
			Else
				scrollComment.Initialize("")
				scrollComment.SetHScrollVisibility("AS_NEEDED")
				scrollComment.InnerNode = comment
				commentHeight = field(4)
				fh_panel.AddNode(scrollComment,offsetX, offsetTop, commentWidth, commentHeight)	' height imposed
				setInMap(field(1),2,scrollComment)
			End If
		else If wdgType = "TIME" Then 	' Date
			txtProto = setText(field)
			field(5) = "0 23 0"
			Dim sld As Slider = createSlider(field,"hourSlider")
			fh_panel.AddNode(sld,offsetX + dimLabels, offsetTop, 3 * field(3) * charWidth, deltaY*0.7)
			field(5) = "0 59 0"
			Dim sld2 As Slider = createSlider(field,"minSlider")
			fh_panel.AddNode(sld2,offsetX + dimLabels, offsetTop + deltaY*0.5, 4 * field(3) * charWidth, deltaY*0.7)
			fh_panel.AddNode(txtProto,sld.left +  4 * field(3) * charWidth , offsetTop+7,field(3) * charWidth, getHeight(1)-2)
			widgetRef.Put(field(1),Array As Object (sld,wdgType,lblx,txtProto,sld2,txtProto.Left+field(3) * charWidth))
		else If wdgType = "DATE" Then 	' Date
			Dim dt As DatePicker
			dt.Initialize("")
			If field(5) <> "" Then dt.DateFormat = field(5)
			If field(6) <> "" Then dt.TooltipText = field(6)
			dt.Tag = field(1)
			fh_panel.AddNode(dt,offsetX + dimLabels, offsetTop, field(3) * charWidth, deltaY*0.7)
			widgetRef.Put(field(1),Array As Object (dt,wdgType,lblx,"","",dt.Left+field(3) * charWidth))
		else If wdgType = "A" Then 	' text area
			Dim t As TextArea = setTextArea(field)
			If field(6) <> "" Then t.TooltipText = field(6)
			t.Tag = field(1)
			CSSUtils.SetStyleProperty(t, "-fx-font-size", "12")
			If field(5) <> "" Then t.PromptText = field(5)
			fh_panel.AddNode(t,offsetX + dimLabels , offsetTop, textWidth * charWidth, getHeight(Ceil(field(3)/textWidth)))
			Dim l As Label = setEraser(field)
			Dim leftEraser As Int = - 16 + t.Left + textWidth * charWidth
			fh_panel.AddNode(l,leftEraser, offsetTop, 25, 25)
			widgetRef.Put(field(1),Array As Object (t,wdgType,lblx,t,"",t.Left+textWidth * charWidth))
		Else	' texts types
			txtProto = setText(field)
			If numericTypes.ContainsKey(wdgType) Then' numerics fields
				CSSUtils.SetStyleProperty(txtProto, "-fx-alignment", "CENTER-RIGHT")
			End If
			If wdgType = "S" Or wdgType = "QS" Then	' *** slide ***
				Dim sldProto As Slider = createSlider(field,"Slide")
				If wdgType = "QS" Then txtProto.Editable = False
				Dim align As String = "center"
				If wdgType = "S" Then align = align & "-right"
				CSSUtils.SetBorder(txtProto,1,fx.Colors.LightGray,5)
				CSSUtils.SetBackgroundColor(txtProto, fx.Colors.ARGB(255,240,240,240))
				CSSUtils.SetStyleProperty(txtProto, "-fx-alignment", align)
				fh_panel.AddNode(sldProto,offsetX + dimLabels, offsetTop, width*3, deltaY*0.7)
				fh_panel.AddNode(txtProto,offsetX+8 + dimLabels + width*3 , offsetTop,field(3) * charWidth, getHeight(1)-2)
				widgetRef.Put(field(1),Array As Object (sldProto,wdgType,lblx,txtProto,"",txtProto.left+field(3) * charWidth))
			Else	' this is a text field I suppose
				If field(5) <> "" Then txtProto.PromptText = field(5)
				fh_panel.AddNode(txtProto,offsetX + dimLabels , offsetTop, field(3) * charWidth, getHeight(Ceil(field(3)/textWidth)))
				Dim l As Label = setEraser(field)
				Dim leftEraser As Int = - 16 + offsetX + dimLabels + field(3) * charWidth
				If numericTypes.ContainsKey(wdgType) Then leftEraser = offsetX + dimLabels	'txtProto.Left
				fh_panel.AddNode(l,leftEraser, offsetTop, 25, 25)
				widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lblx,txtProto,"",leftEraser+25))
			End If
		End If
		If Not(after.ContainsKey(field(1))) Then
			Private pnlHeight As Int =   getHeight(Ceil(field(3)/textWidth))
			Select wdgType
				Case "A"
					pnlHeight = pnlHeight + 10
				Case "C"
					pnlHeight = commentHeight 	' getHeight(Floor(nLL/1000))
				Case "CKL"
					pnlHeight = ckList.size * (deltaY-5)
				Case "CMX"
					pnlHeight = pnlHeight + deltaY
				Case "TIME"
					pnlHeight = pnlHeight + deltaY*0.2
			End Select
			If Not("IB*C*TB*".Contains(wdgType & "*")) Then fh_panel.AddNode(lblx,offsetX, offsetTop+0.5*(pnlHeight-getHeight(1)), dimLabels, getHeight(1))	' label
		If wdgType <> "B" Then offsetTop = offsetTop + pnlHeight + 10	' lineHeight
		End If
	Next
	' what buttons?
	Dim buttonsWidth As Int = 0
	Dim sWidth As Int = 0
	If (lonely Mod 97) <> 1 Then ' if no only one ComboBox
		Dim pnlButtons As Pane
		pnlButtons.Initialize("")
		buttonsWidth = createPanelButtons(pnlButtons)
		sWidth = buttonsWidth
	End If
	For Each k As String In widgetRef.Keys
		Dim a() As Object = widgetRef.Get(k)
		sWidth = Max(sWidth,a(5))
	Next
	sWidth = sWidth + 6
	If (lonely Mod 97) <> 1 Then fh_panel.AddNode(pnlButtons,0.5*(sWidth - buttonsWidth),offsetTop,sWidth, deltaY)
'	possible button after title **************************************************	
	If hasTitle Then 
		fh_panel.AddNode(lblTitle,0 , 0, sWidth, titleHeight)
		Dim s As String = getFromNodeMap(lblTitle.Tag,3)	' possible button after title
		If s <> "" And s <> 0 Then
			Dim f() As String = Elem.Get(s)
			Dim event As String = IIf(f(1) = "Cancel","Cancel","afterButtons")
			Dim btn As Button = CreateButton(s,f(2),event,"B")
			Dim afterNode As Node = getFromNodeMap(after.Get(s),0)
			fh_panel.AddNode(btn,afterNode.Left+afterNode.PrefWidth-f(3),afterNode.Top,f(3),btnHeight)
		End If
	End If
	'	possible adjust comments **************************************************
	For Each k As String In Elem.Keys
		Dim f() As String = Elem.get(k)
		If f(0) = "C" Then
			If containsParm("center|fill",f(5)) Then
				Dim comment As Label = getHandle(f(1))
				comment.SetSize(sWidth-2*offsetX,comment.Height)
				Dim scroll As Object = getFromNodeMap(f(1),2)
				If TypeOf(scroll) = "ScrollPane" Then 
					Dim scroll2 As ScrollPane = scroll
					scroll2.SetSize(sWidth-2*offsetX,f(4))
				End If
			End If
		End If
	Next
	Dim topPanel As Double = 0
	If menuList.Size > 0 Then
		Dim menu As MenuBar = createMenu(implode(";",menuList))
		topPanel = 25
	End If
	Dim sHeight As Int = offsetTop + IIf( buttonsWidth > 0 ,deltaY+5dip,0) + topPanel
	If isWindow Then
		fh_ground.Initialize("")
		Dim fh_shadow As Pane
		fh_shadow.Initialize("")
		setBackground(window,fh_shadow)
		If containsParm("shadow",window(2)) Then
				fh_ground.AddNode(fh_shadow,10,10,sWidth,sHeight)
				Dim canv As B4XCanvas
				canv.Initialize(fh_shadow)
				Dim rect As B4XRect
				rect.Initialize(0,0,sWidth,sHeight)
				canv.DrawRect(rect,0X3F000000,True,0)
				canv.Initialize(fh_shadow)
		Else If	containsParm("border",window(2)) Then
				Dim colorLine As Paint = decodeColor(extractParm("border",window(2)))
				If colorLine = fx.Colors.Transparent Then colorLine = fx.Colors.ARGB(127,0,0,0)
				CSSUtils.SetBorder(fh_panel,2,colorLine,3)
		End If
		fh_ground.AddNode(fh_panel,0,0,sWidth,sHeight)
		handleEvents(Array As Object ("fh_start","Window","",fh_ground,sWidth+10,sHeight+10))
		setDefaults(False)
		Return
	End If
	frm.Initialize("frm", sWidth, sHeight)
	frm.Title = title
	frm.AlwaysOnTop = True
	If stylesheet <> "" Then
		frm.Stylesheets.Add(File.GetUri(File.DirAssets,stylesheet))
	End If
	If menuList.Size > 0 Then frm.RootPane.AddNode(menu,0,0,sWidth,25)
	If Sections.Length > 1 And fh_Data.Size > 0 Then
		setDefaults(False)
	Else
		setDefaults(True)
	End If
	' manage menu
	frm.RootPane.AddNode(fh_panel,0,topPanel,frm.Width,frm.Height)
	frm.Show
	handleEvents(Array As Object ("fh_start","Start","",title,Section))
End Sub
Sub showMessage(msg As String,tit As String)
	If isWindow Then
		Dim frmMessage As Form
		frmMessage.Initialize("",250,100)
		frmMessage.Title = tit
		frmMessage.AlwaysOnTop = True
		Dim l As Label
		l.Initialize("")
		l.Text = msg
		frmMessage.RootPane.AddNode(l,2,2,248,98)
		frmMessage.Show
	Else
		fx.Msgbox(frm,msg,tit)
	End If
End Sub
Private Sub setDefaults(reset As Boolean)	' true if is from reset button
	For Each k As String In Defaults.Keys
		setValue(k,Defaults.Get(k))
		If Not(reset) Then
			If fh_Data.ContainsKey(k) Then setValue(k,fh_Data.Get(k))	' data from another section
		End If
	Next
End Sub
Private Sub getHeight(rows As Int) As Int
	Return 10 + rows * lineHeight	' font size 12 height = 18
End Sub
Sub commentDimension(c As String,fontSize As Int) As Int()	' returns lines number and max dimension
	Dim l As List,ll As Int = 0
	l.Initialize2(Regex.Split("\r\n|\r|\n",c))
	Dim r As B4XRect
	For i=0 To l.Size -1
		r = measureText(l.Get(i),fontSize)
		ll = Max(ll,r.Width)
	Next
	Return Array As Int(l.Size, ll)
End Sub
Sub mask(d As String) As String	' mask comma, semicolon apostrophes
	Dim data As String = d
	Dim  rge As String = $"(,)|(;)|(')|(")|(\n)"$
	Dim M As Matcher = Regex.Matcher(rge, d)
	Do While M.Find
		Dim mtch As Int = Asc(M.Match)
		data = data.Replace(M.Match,replaceMap.Get(mtch))
	Loop
	Return data
End Sub
Sub deMask(text As String)	As String
	If text.StartsWith("@") Then text = fhSubstMap.GetDefault(text,text)
	Dim Match As Matcher = Regex.Matcher(reDeMask, text)
	Do While Match.Find
		If (Match.Match).ToUpperCase.CharAt(1) = "X" Then
			text = text.Replace(Match.Match,Chr(Bit.ParseInt(Match.Match.SubString(2),16)))
		Else
			text = text.Replace(Match.Match,Chr(Bit.ParseInt(Match.Match.SubString(1),10)))
		End If
	Loop
	Return replace(text)
End Sub
Sub quoteMask(params As String) As String
	Dim pattern As String = $"[,:]?('(.*?)'|"(.*?)")[,;]"$		' //sm    [,;]('(.*?)'|"(.*?)")[,;]
	Dim ck As Int
	Do While True
		Dim m As Matcher = Regex.Matcher2(pattern, Regex.MULTILINE,params & ";")
		If m.Find Then
			ck = ck + 1
			For g = 2 To m.GroupCount
				If m.Group(g) <> Null Then
					fhSubstMap.Put("@" & ck,params.SubString2(m.getStart(g),m.getEnd(g)))
					params = params.SubString2(0,m.getStart(g)-1) & "@" & ck & params.SubString(m.getEnd(g)+1)
				End If
			Next
		Else
			Exit
		End If
	Loop
	Return params
End Sub
Sub replace(what As String) As String
	Dim memDateFormat As String = DateTime.DateFormat	' save date format
	DateTime.DateFormat = "ddMMyyyy"
	Dim dt As Long = DateTime.DateParse("07012018")	' because is sunday
	Dim x As String = ""
	Select what.ToLowerCase
		Case "%days", "%#days"
			DateTime.DateFormat = "EEEE"
			For i = 1 To 7
				x = x  & "|" & IIf(what.StartsWith("%#"),i & ":","") & DateTime.Date(dt)
				dt = DateTime.Add (dt, 0, 0, 1)
			Next
		Case "%months", "%#months"
			DateTime.DateFormat = "MMMM"
			For i= 1 To 12
				x = x  & "|" & IIf(what.StartsWith("%#"),i & ":","") & DateTime.Date(dt)
				dt = DateTime.Add (dt, 0, 1, 0)
			Next
	End Select
	DateTime.DateFormat = memDateFormat	' restore date format
	If x.Length = 0 Then Return what	' unchanged
	Return x.SubString(1)
End Sub
Sub Left(s As String,l As Int) As String
If l < s.Length Then Return s.SubString2(0,l)
Return s
End Sub
Sub Right(s As String,l As Int) As String
If l < s.Length Then Return s.SubString(s.Length-l)
Return s
End Sub
Sub splitKeyValue(name As String,data As String) As List ' split key value (combos, qualitative sliders AND option buttons)
	Dim dt(),key,value As String,k As Int 
	Dim lst As List
	lst.Initialize
	If data.Length > 0 Then
		dt = Regex.Split("\|", data)
		For j = 0 To dt.Length - 1
			If dt(j).IndexOf(":") < 0 Then dt(j)=dt(j) & ":" & dt(j)
			k = dt(j).IndexOf(":")
			key = deMask(dt(j).SubString2(0,k))
			value = dt(j).SubString(k+1)
			mapValues.Put(name & value,key)
			mapValues.Put(name & key,value)
			lst.add(value)
		Next
	End If
	Return lst
End Sub
Private Sub File_action
	Dim s As Button = Sender
	Dim fld() As String = Elem.Get(s.Tag)
	Dim txt As TextField = getHandle(s.tag)	
	handleEvents(Array As Object (s.Tag,"CLICK",txt))
	Dim f As String = valueOf(s.Tag)
	Private m As Map = pathinfo(f)
	If fld(0) = "D" Then
		Dim DC As DirectoryChooser
		DC.Initialize
		DC.Title = fld(2)
		DC.InitialDirectory = m.Get("dirname")
		f = DC.Show(frm)
	Else
		Dim sExtension As String = implodeFrom(",",fld,6,16) ' file type is from II extra field
		Private fc As FileChooser
		fc.Initialize
		fc.Title = fld(2)
		If sExtension <> "" And fld(5) <> "" Then fc.SetExtensionFilter(fld(5),Regex.Split(",", sExtension))
		fc.InitialDirectory = m.Get("dirname")
		fc.InitialFileName = m.Get("filename")
		If fld(0) = "WF" Then
			f = fc.ShowSave(frm)
		Else
			f = fc.ShowOpen(frm)
		End If
	End If
		If f <> "" Then
		setValue(s.Tag,f)
	End If
End Sub
Private Sub fh_CallSub2(module As Object,fnz As String,parm As Object)
	Dim dt() As Object = Regex.Split("\.", fnz & "." & fnz)
	If dt.Length = 4 Then module = dt(0)
	Dim xui As XUI
	Try
		If xui.SubExists(module,dt(1),0) Then
			CallSubDelayed2(module,dt(1),parm)	' there is a callback
		Else
			showMessage(dt(1),title)
		End If
	Catch
		showMessage(module & " isn't a code module",title)
	End Try
End Sub
Private Sub Reset_Action
	Dim k() As Object = allButtons.Get("Reset")
	If k(5) <> "" Then
		If fx.Msgbox2(frm, k(5), "formGen", "Yes", "", "No", fx.MSGBOX_CONFIRMATION) <> fx.DialogResponse.POSITIVE Then Return
	End If
	setDefaults(True)
	handleEvents(Array As Object ("fh_reset","Reset",0,"",Section))
End Sub
Private Sub IButtons_Action		' *** handle IB and toggle
	Dim btnNode As Button = Sender
	Dim btnTag As String = btnNode.Tag
	handleEvents(Array As Object (btnTag,"CLICK",btnNode))
	Dim f() As String = Elem.Get(btnTag)
	If getNodeType(btnNode.tag) = "TB" Then
		Dim lst As List = getFromNodeMap(btnNode.Tag,3)
		Dim i As Int = (lst.IndexOf(btnNode.text) + 1) Mod lst.Size
		btnNode.text = lst.Get(i)
		btnNode.TooltipText = mapValues.GetDefault(btnTag & btnNode.text,"")
	Else
		If f(5) <> "" Then fh_CallSub2(fh_module,f(5),btnTag)	' there is a callback
	End If
End Sub
Private Sub afterButtons_Action		' after buttons
	Dim btnNode As Node = Sender
	Dim btnTag As String = btnNode.Tag
	handleEvents(Array As Object (btnTag,"CLICK",btnNode))
	Dim f() As String = Elem.Get(btnTag)
	fh_CallSub2(fh_module,f(5),btnTag)
End Sub
Private Sub Cancel_Action
	Dim k() As Object = allButtons.Get("Cancel")
	If k(5) <> "" Then
		If fx.Msgbox2(frm, k(5), "formGen", "Yes", "", "No", fx.MSGBOX_CONFIRMATION) <> fx.DialogResponse.POSITIVE Then Return
	End If
	fh_Data.Clear
	fh_Data.Put("fh_button", "Cancel")
	handleEvents(Array As Object ("fh_cancel","End","","",Section))
	If fh_returnSub <> "" Then CallSubDelayed2(fh_module,fh_returnSub,fh_Data)
	cleanForm
End Sub
Private Sub Buttons_Action		' *** exit routin
	Dim btnNode As Node = Sender
	Dim btnTag As String = btnNode.Tag
	handleEvents(Array As Object (btnTag,"CLICK",btnNode))
	Dim k() As Object = allButtons.Get(btnTag)
	If k(2) <> "" Then
		fh_CallSub2(fh_module,k(2),btnTag)
		Return
	End If
	If CheckErrors(btnTag,True) Then		
		If btnTag = "fh_Forward" Or btnTag = "fh_Back" Then
			handleEvents(Array As Object (btnTag,"End","",Section))
			Section = Section + IIf(btnTag = "fh_Forward",1, -1)
			Dim condition As Boolean = False
			Do While Not(condition)
				condition = True
				Dim conditions() As String = Regex.Split(",",Sections(Section,2))
				For i = 0 To conditions.Length - 1
					Matcher1 = Regex.Matcher2(reOperands,Regex.CASE_INSENSITIVE,conditions(i))
					If Not(Matcher1.Find) Then Continue
					Dim fieldName As String = Matcher1.Group(1)
					If Not(compare(numericTypes.GetDefault(fh_FieldsType.GetDefault(fieldName,False),False),fh_Data.GetDefault(fieldName,""),Matcher1.Group(2).Trim.ToLowerCase,deMask(Matcher1.Group(3)))) Then
						condition = False
					End If
				Next
				If condition Then
					CallSubDelayed3("","fgSection", Sections(Section,0),fh_Data)
				Else
'					ToastMessageShow("Session " & Sections(Section,1) & " not activated for condition '" & Sections(Section,2) & "'",True)
					Section = (Section + IIf(btnTag = "fh_Forward",1, - 1)) Mod Sections.Length
				End If
			Loop
			cleanForm
		Else
			setHiddens
			handleEvents(Array As Object ("fh_end","End"))
			cleanForm
			If fh_returnSub = "" Then Return
			CallSubDelayed2(fh_module,fh_returnSub,fh_Data)
		End If
	End If
End Sub
Sub setHiddens
	For Each key In hiddensMap.Keys	' hidden data?
		fh_Data.Put(key,hiddensMap.Get(key))
	Next
End Sub
Private Sub CheckErrors(btnTag As String, check As Boolean)	As Boolean	' for button end ComboBox aka button list
	Private signal As String = ""
	For Each k As String In widgetRef.Keys
		Dim vType As String = viewType(k)
		field = Elem.Get(k)
		If "B*C*TITLE*".Contains(vType & "*") Then Continue	' not fields
		Dim wdgtValue As String = valueOf(k)
		If (checks.ContainsKey(k) Or required.ContainsKey(k)) And check Then
			Dim s As String = checkField(k,wdgtValue)
			If s <> "" Then signal = IIf(signal = "",s,signal & "," & CRLF &  translate(s))
		End If
		fh_Data.Put(k,wdgtValue)	' set wiew value
		If vType = "CMB" Or vType = "R"  Or vType = "QS" Then fh_Data.Put("fh_" & k,mapValues.Get(k & wdgtValue))
	Next
	If signal = "" Then		
		fh_Data.Put("fh_button",btnTag)
	Else
		showMessage(signal,title)
		Return False
	End If
	Return True
End Sub
private Sub checkField(name As String, wdgtValue As String) As String
	Private signal As String = ""
	Dim wdgl As Label = getFromNodeMap(name,2)
	CSSUtils.SetStyleProperty(wdgl,"-fx-text-fill","black")
	If required.ContainsKey(name) Then
		If wdgtValue = "" Then Return setError(wdgl,signal,name & ": required")
		If Not(checks.ContainsKey(name)) Then Return ""
	End If
	Private check As List
	check.Initialize
	check.AddAll(checks.Get(name))
	For j = 0 To check.size - 1
		Dim strCheck(2) As String =  check.get(j)
		Matcher1 = Regex.Matcher2(reOperands,Regex.CASE_INSENSITIVE,strCheck(0))
		If Not(Matcher1.Find) Then Continue
		Dim operand As String = deMask(Matcher1.Group(3))
		Dim operator As String = Matcher1.Group(2).Trim
		If operator.ToLowerCase <> "is" Then
			If Elem.ContainsKey(operand) Then operand = valueOf(operand)	' compare with field
			If Not(compare(numericTypes.GetDefault(fh_FieldsType.get(name),False),valueOf(name),operator.Trim.ToLowerCase,operand)) Then
				signal = setError(wdgl,signal,name & ": " & strCheck(1))
			End If
		Else
			If operand.ToLowerCase() = "mail" Then
				If Not(Regex.IsMatch(reMail,wdgtValue)) Then signal = setError(wdgl,signal,name & ": " & strCheck(1))
			Else 		' my be a regular expression
				If wdgtValue <> "" And Not(Regex.IsMatch(deMask(operand),wdgtValue)) Then signal = setError(wdgl,signal,name & ": " & strCheck(1))
			End If
		End If
	Next
	Return signal
End Sub
Private Sub setError(l As Label,signal As String,s As String) As String
	CSSUtils.SetStyleProperty(l,"-fx-text-fill","red")
	Return IIf(signal = "",s,signal & Chr(10) & s)
End Sub
Private Sub compare(Numeric As Boolean,wdgtValue As String, operator As String, operand As String) As Boolean
	Dim cfr As Int = 1	' means equal
	If Numeric Then		' numeric field
		If wdgtValue = "" Then Return True			' no data - no compare
		If Not(IsNumber(operand)) Then Return True	' no data - no compare
		If wdgtValue > operand Then cfr = 2
		If wdgtValue < operand Then cfr = 4
	Else
		Dim cfr As Int = wdgtValue.CompareTo(operand)
		If cfr > 0 Then cfr = 2
		If cfr < 0 Then cfr = 4
		If cfr = 0 Then cfr = 1
	End If
	If Bit.And(cfr,comparator.Get(operator)) = 0 Then Return False	' trim if operator is string, ex. EQ LT ...
	Return True
End Sub
Private Sub handleEvents(parms() As Object)
	If fh_handleSub <> "" Then
		CallSub2(fh_module,fh_handleSub,parms)
	End If
End Sub
private Sub comboCMX_ValueChanged(value As String)
	Dim cmb As ComboBox = Sender
	handleEvents(Array As Object (cmb.Tag,"CLICK",cmb,value))
	Dim txtArea As TextArea = getFromNodeMap(cmb.tag,0)
	If Not(txtArea.Text.Contains(value)) Then
		If txtArea.Text <> ""  Then  txtArea.Text =  txtArea.Text & Chr(10)
		txtArea.Text = txtArea.Text & value
	End If
End Sub
private Sub combos_ValueChanged(value As String)
	Dim cmb As ComboBox = Sender
	handleEvents(Array As Object (cmb.Tag,"CLICK",cmb,valueOf(cmb.tag)))
	If (lonely Mod 97) = 1 Then		' only one ComboBox
		handleEvents(Array As Object ("fh_end","End"))
		fh_Data.Put(cmb.tag,valueOf(cmb.tag))
		fh_Data.Put("fh_"&cmb.tag,valueOf("fh_"&cmb.tag))
		fh_Data.Put("fh_button",cmb.Tag)
		setHiddens
		If fh_returnSub <> "" Then CallSubDelayed2(fh_module,fh_returnSub,fh_Data)
		cleanForm
'		cmb.TooltipText = getFromNodeMap(cmb.Tag,3)
	End If
End Sub
Private Sub Combos_SelectedIndexChanged(Position As Int, Value As Object)
End Sub
Private Sub RadioButton_SelectedChange(selected As Boolean)
	If selected Then
		Dim rdb As RadioButton= Sender
		setInMap(rdb.Tag,3,rdb)
		handleEvents(Array As Object (rdb.tag,"CLICK",Sender,mapValues.get(rdb.Tag & rdb.text)))
	End If
End Sub
Sub AreaTxt_FocusChanged (HasFocus As Boolean)
	Dim focusedText As TextArea = Sender
	handleEvents(Array As Object (focusedText.tag,IIf(HasFocus,"FOCUS","LFOCUS"),Sender,focusedText.text))
End Sub
Sub txt_Action
	If lonely = 2 Then
		setHiddens
		Dim txt As TextField = Sender
		fh_Data.Put(txt.Tag,txt.Text)
		fh_Data.Put("fh_button",txt.Tag)
		handleEvents(Array As Object ("fh_end","End"))
		CallSubDelayed2(fh_module,fh_returnSub,fh_Data)
		cleanForm
	End If
End Sub
Sub txt_FocusChanged (HasFocus As Boolean)
'	If lonely = 2 And Not(HasFocus) Then 
'		cleanForm
'		Return	' the field has already been closed
'	If lonely = 2 And Not(HasFocus) Then 
'		cleanForm
'		Return	' the field has already been closed
'	End If
	Dim focusedText As TextField = Sender
	handleEvents(Array As Object (focusedText.tag,IIf(HasFocus,"FOCUS","LFOCUS"),focusedText,focusedText.text))
	If Not(HasFocus) Then
'		If lonely = 2 Then cleanForm
		If Not(checks.ContainsKey(focusedText.Tag)) Then Return
		Dim signal As String = checkField(focusedText.Tag,focusedText.Text)	' checks data
		If signal <> "" Then
			showMessage(signal,title)
		End If
	End If
End Sub
Sub txt_TextChanged(Old As String, New As String)
	If New = "" Then Return
	If IsUpdatingText = True Then Return
	IsUpdatingText = True
	Dim txt As TextField = Sender
	Dim selStart As Int = txt.SelectionStart
	Dim nodeType As String = getNodeType(txt.Tag)
	If nodeType = "N" Or nodeType = "DN" Then
		Dim pattern As String = "^[-+]?\d+$"	' integer signed pattern
		If nodeType = "DN" Then pattern = "^[-+]?\d+(\.\d*)?$"	' decimal signed pattern
		If Not(Regex.IsMatch(pattern,New)) Then
			txt.Text = Old
			txt.SetSelection(selStart-1,selStart-1)
		End If
	End If
	IsUpdatingText = False
End Sub
Private Sub checkBox_CheckedChange(Checked As Boolean)
	Dim ckb As CheckBox = Sender
	handleEvents(Array As Object (ckb.tag,"CKB",ckb,IIf(Checked,"1","0")))
End Sub
private Sub minSlider_ValueChange(Value As Double)
	Dim sld As Slider = Sender
	Dim txtSlider  As TextField = getFromNodeMap(sld.Tag,3)
	Dim sld2 As Slider =  getFromNodeMap(sld.Tag,0)	' hour
	Dim tick As Long = (Floor(sld2.Value+23)*60 + Floor(sld.Value))*60000
	DateTime.TimeFormat = "HH:mm"
	txtSlider.Text = DateTime.Time(tick)
End Sub
private Sub hourSlider_ValueChange(Value As Double)
	Dim sld As Slider = Sender
	Dim txtSlider  As TextField = getFromNodeMap(sld.Tag,3)
	Dim sld2 As Slider =  getFromNodeMap(sld.Tag,4)	' minutes
	Dim tick As Long = (Floor(sld.Value+23)*60 + Floor(sld2.Value))*60000
	DateTime.TimeFormat = "HH:mm"
	txtSlider.Text = DateTime.Time(tick)
End Sub
Private Sub Slide_ValueChange (Value As Double)
	Dim sld As Slider = Sender
	Dim txtSlider  As TextField = getFromNodeMap(sld.Tag,3)
	If getFromNodeMap(sld.Tag,1) = "QS" Then
		Private listQs As List = Limits.Get(sld.Tag)
		txtSlider.text = listQs.Get(IIf(Value = listQs.Size,listQs.Size-1,Floor(Value)))
		handleEvents(Array As Object (sld.Tag,"SLIDE",sld,txtSlider.text,getFromNodeMap(sld.tag,3)))
	Else
		txtSlider.text = NumberFormat(Value,1,Limits.get(sld.Tag & "Decimals"))
		handleEvents(Array As Object (sld.Tag,"SLIDE",sld,Floor(Value),getFromNodeMap(sld.tag,3)))
	End If
End Sub
Sub TypeOf(obj As Object) As String
	Dim t() As String = Regex.Split("\.",GetType(obj))
	Return t(t.Length-1)
End Sub
Private Sub setInMap(fld As String,pos As Int,val As Object)	' From field widget map parameters field, position
	Dim aWdg() As Object
	If Not(widgetRef.ContainsKey(fld)) Then Return 
	aWdg = widgetRef.get(fld)
	If pos < aWdg.Length Then
		aWdg(pos) = val
		widgetRef.Put(fld,aWdg)
	End If
End Sub
Sub fileInfo(flName As String, info As String) As String
	Return pathinfo(flName).GetDefault(info,"")
End Sub
Sub pathinfo(dir As String) As Map
	Dim fInfo As Map = CreateMap("dirname":File.DirApp,"extension":"","filename":"","basename":"")
	If File.IsDirectory(dir,"") Then
		fInfo.Put("dirname",dir)
	Else
		Dim k As Int = dir.LastIndexOf("\")
		If k >= 0 Then 	fInfo.Put("dirname",Left(dir,k+1))
		Dim fl As String = dir.SubString(k+1)
		fInfo.Put("basename",fl)
		k = fl.LastIndexOf(".")
		fInfo.Put("filename",fl)
		If k >= 0 Then 
			fInfo.Put("filename",Left(fl,k))
			fInfo.Put("extension",fl.SubString(k+1))
		End If
	End If
	Return fInfo
End Sub
Private Sub addCheck(sField As String,check() As String)
	Private a As List
	a.Initialize
	If checks.ContainsKey(sField) Then a = checks.Get(sField)
	a.add(check)
	checks.Put(sField,a)
End Sub
Sub enable(Name As String)
	SetWidget(Name,"Enable")
End Sub
Sub disable(Name As String)
	SetWidget(Name,"Disable")
End Sub
Private Sub SetWidget(Name As String, option As String)
	Dim aWdg() As Object = widgetRef.GetDefault(Name,Array As Object(0))	
	If aWdg.Length = 1 Then Return	' key exist?
	Dim v As Node = aWdg(0)
	Dim opt As String = option.ToLowerCase
	Select opt
		Case "enable","disable"
			If TypeOf(v) = "Button" Or TypeOf(v) <> "BALayout" Then 
				v.Enabled = IIf(opt = "enable",True,False)
			Else
				pnl = aWdg(0)
				For i = 0 To pnl.NumberOfNodes -1
					pnl.GetNode(i).Enabled = IIf(opt = "enable",True,False)
				Next
			End If
	End Select
End Sub
Sub getHandle(Name As String) As Object
	Dim aWdg() As Object = widgetRef.GetDefault(Name,Array As Object(Null))
	Return aWdg(0)
End Sub
Private Sub getFromNodeMap(fld As String,pos As Int) As Object	' From field widget map parameters field, position
	Dim aWdg() As Object = widgetRef.GetDefault(fld,Array As Object(0))
	If aWdg.Length = 1 Then Return 0 
	aWdg = widgetRef.get(fld)
	If pos < aWdg.Length Then Return aWdg(pos)
	Return 0
End Sub
Sub getNodeType(Name As String) As String
	Return getFromNodeMap(Name,1)
End Sub
Sub GetDate(dateNode As DatePicker, Name As String)  As String
	Dim f() As String = Elem.Get(Name)
	Dim dateFormat As String = DateTime.DateFormat	' save date format
	If f(5) <> "" Then DateTime.DateFormat = f(5)
	Dim date As String = "" 
	If dateNode.DateTicks > 0 Then date = DateTime.Date(dateNode.DateTicks)
	DateTime.DateFormat = dateFormat	' restore date format
	Return date
End Sub
Sub normalizeLabel(s As String) As String
	s = Regex.Replace("(.+?)([a-z])([A-Z])(.*)",s,"$1$2 $3$4")	' separe words aaaBbb
	s = s.Replace("_"," ")
	Dim i As Int = s.IndexOf(" ")
	If i = -1 Then Return s
	Return s.SubString2(0,1).ToUpperCase &  s.SubString2(1,i+1) & s.SubString2(i+1,i+2).ToLowerCase & s.SubString(i+2)
End Sub
Sub setComboValues(Name As String,values As String) As Int
	Select getNodeType(Name)
		Case "CMB"
			Dim cmb As ComboBox = getFromNodeMap(Name,0)
		Case "CMT","CMX"
			Dim cmb As ComboBox = getFromNodeMap(Name,3)
	End Select
	cmb.Items.Clear
	cmb.items.addall(splitKeyValue(Name,values))
	Return cmb.items.Size
End Sub
Sub SetDate(value As String,format As String) As Long
	Dim dt As Long
	Dim dateFormat As String = DateTime.DateFormat	' save date format
	Select value.ToLowerCase
		Case "today","%today","now","%now"
			dt = DateTime.now
		Case "tomorrow","%tomorrow"
			dt = DateTime.Add(DateTime.Now, 0, 0, 1)
		Case "yesterday","%yesterday"
			dt = DateTime.Add(DateTime.Now, 0, 0, -1)
		Case Else
			If format <> "" Then DateTime.DateFormat = format
			If value <> 0 And value <> "" Then
				dt = DateTime.DateParse(value)
			End If
	End Select
	DateTime.DateFormat = dateFormat	' restore date format
	Return dt
End Sub
Sub valueOf(Name As String) As String
	Dim a() As Object
	Dim n As String  = IIf(Name.StartsWith("fh_"),Name.SubString(3),Name)
	If widgetRef.ContainsKey(Name) Or widgetRef.ContainsKey(n) Then a = widgetRef.get(n)
	If a <> Null Then
		Select a(1)		' node type
			Case "A"
				Dim wdgT As TextArea = a(0)
				Return wdgT.text
			Case "DATE"
				Return GetDate(a(0),Name)
			Case "TIME"
				Dim txt As TextField = a(3)	' text associated to slider
				Return txt.text
			Case "CMB","CMT"
				Dim cmb As ComboBox = a(0)
				If a(1) = "CMB" Then 
					If Name.StartsWith("fh_") Then
						Return cmb.value	' returns value exposed
					End If
					Return mapValues.GetDefault(Name & cmb.Value,"")
				End If
				If cmb.Value = Null Then Return ""
				Return cmb.Value
			Case "CMX"
				Dim wdgTA As TextArea = a(0)
				Return wdgTA.text				
			Case "CKB"
				Dim chk As CheckBox = a(0)
				Return (IIf(chk.Checked,"1","0"))
			Case "CKL"
				Dim l As List =  a(3)
				Dim checkCount As Int = 0
				For j = 0 To l.Size-1
					Dim chk As CheckBox = getFromNodeMap(mapValues.get(field(1) & l.get(j)),0)
					If chk.Checked Then checkCount = checkCount + 1			
				Next
				Return checkCount
			Case "S","QS"	' Slider
				Dim txt As TextField = a(3)
				If a(1) = "S" Then Return txt.text.Replace(",","")	' there can be thousands separators
				Return mapValues.get(Name & txt.text)
			Case "TB"
				Dim btn As Button = a(0)
				Return mapValues.get(Name & btn.text)
			Case "U","UN","C"		' Unmodifiables
				Dim uLbl As Label = a(0)
				Return uLbl.text
			Case "R"		' RadioButton
				If a(3) = Null Then Return ""
				Dim rdb As RadioButton = a(3)
				Return mapValues.get(Name & rdb.text)
			Case "B","IB"
				Return Name
			Case "H"
				Return hiddensMap.GetDefault(Name,"")
			Case Else	' text Nodes also CMX combo text
				Dim txt As TextField = a(0)
				Return txt.text
		End Select	
	End If
	Return ""
End Sub
Sub implode(sep As String,obj As List) As String
	Return implodeFrom(sep,obj,0,obj.Size)
End Sub
Sub implodeFrom(sep As String, obj As List, From As Int, At As Int) As String
	Dim implStr As String = ""
	For j = obj.size -1 To From Step -1	' delete last empty items 
		If obj.Get(j) <> "" Then Exit
	Next
	For i = From To Min(At,j)
	     implStr =  implStr & sep & obj.Get(i)
	Next
	If implStr.Length > 0 Then Return implStr.SubString(1)
	Return ""
End Sub
Sub setValue(Name As String,Value As String)
	Dim wdg As Object = IIf(widgetRef.ContainsKey(Name),getFromNodeMap(Name,0),Null)
	If wdg = Null Then Return	' no field
	Select getNodeType(Name)
		Case "A"
			Dim areaTxt As TextArea = wdg
			areaTxt.text = Value
		Case "C","U","UN"
			Dim uLbl As Label = wdg
			uLbl.text = Value
		Case "CKB"
			Dim chk As CheckBox = wdg
			chk.Checked = IIf(Left(Value,5).ToLowerCase = "check" Or Value = "1", True,False)
		Case "CKL"
		Case "CMB","CMT"
			Dim cmb As ComboBox = wdg
			cmb.SelectedIndex = cmb.Items.IndexOf(Value)
			If cmb.SelectedIndex = -1 Then	' may be is the key
				cmb.SelectedIndex = cmb.Items.IndexOf(mapValues.GetDefault(Name & Value,""))				
			End If
		Case "CMX"
			Dim cmb As ComboBox = getFromNodeMap(Name,3)
			Dim txtArea As TextArea = wdg
				txtArea.Text = Value
		Case "S"
			Dim sld As Slider = wdg
			Dim txt As TextField = getFromNodeMap(sld.Tag,3)
			If IsNumber(Value) Then
				sld.Value = Value
				txt.Text = NumberFormat(Value,1,Limits.get(Name & "Decimals"))
			Else
				sld.Value = 0
				txt.Text = ""
			End If
		Case "TIME"			
			Dim sld As Slider = wdg
			Dim txt As TextField = getFromNodeMap(sld.Tag,3)
			Dim a() As String = Regex.Split("\s*:\s*",Value)
			If a.Length = 1 And IsNumber(Value) Then
				sld.Value = Value Mod 24
				txt.Text = NumberFormat(sld.Value,2,0) & ":00"
			Else If a.Length = 2 Then
				txt.Text = NumberFormat(a(0) Mod 24,2,0) & ":" & NumberFormat(a(1) Mod 60,2,0)
				sld.Value = a(0) Mod 24
				Dim sld2 As Slider = getFromNodeMap(Name,4)
				sld2.Value = a(1) Mod 60
			Else	' not s et default values
				sld.Value = 0
				Dim sld2 As Slider = getFromNodeMap(Name,4)
				sld2.Value = 0
				txt.Text = ""
			End If
		Case "QS"
			Dim sld As Slider = wdg
			Dim txt As TextField = getFromNodeMap(sld.Tag,3)
			Private listQs As List = Limits.Get(Name)
			sld.Value = listQs.IndexOf(Value) + 0.5
		Case "T","N","DN","P","F","WF","D"
			Dim txt As TextField = wdg
			txt.text = Value
		Case "R"
			pnl = getFromNodeMap(Name,0)
			Dim v As Node
			setInMap(Name,3,Null)
			For i = 0 To pnl.NumberOfNodes -1
				v = pnl.GetNode(i)
				If TypeOf(v) = "RadioButton" Then
				Dim rdb As RadioButton = pnl.GetNode(i)
					rdb.Selected = False
					If rdb.text = Value Or rdb.text = mapValues.GetDefault(Name & Value,"") Then 
						rdb.selected = True
						setInMap(Name,3,rdb)
					End If
				End If
			Next
		Case "TB"
			Dim btn As Button = wdg
			btn.Text = mapValues.GetDefault(Name & Value,"")
			btn.TooltipText = mapValues.GetDefault(Name & btn.text,"")
		Case "B","IB"
			Dim btnx As Node = wdg
			btnx.Enabled = IIf(Left(Value,3).ToLowerCase = "dis",False,True)
		Case "DATE"
			Dim dt As DatePicker = wdg
			Dim f() As String = Elem.Get(Name)
			dt.DateTicks = SetDate(Value,f(5))
	End Select
End Sub
Sub decodeColor(s As String) As Paint
	Dim a() As Long = isColor(s)
	Return fx.Colors.From32Bit(a(1))
'	Dim Match As Matcher = Regex.Matcher(reHexaDecimal, C)
'	If Not(Match.Find) Then
'		If colorsMap.ContainsKey(C.ToLowerCase) Then Return colorsMap.get(C.ToLowerCase)
'		C = "00000000"‬
'	End If
'	' length = 3 presumed color on 3 characters so x become xF
'	If C.Length = 3 Then C = Regex.Replace2("[\dABCDEF]",Regex.CASE_INSENSITIVE, C, "$0F")
'	C = "FF000000".SubString2(0,8-C.Length) & C
'	Return fx.Colors.ARGB(Bit.ParseInt(C.SubString2(0,2),16),Bit.ParseInt(C.SubString2(2,4),16),Bit.ParseInt(C.SubString2(4,6),16),Bit.ParseInt(C.SubString2(6,8),16))
End Sub
Sub isColor(s As String) As Long()
	Dim rex As String = "^[\dABCDEF]{1,8}$|(^[\dABCDEF]{2})([A-Z]+)$"	' exadecimal{1,8} or exadecimal{2}color
	Dim a() As Long = Array As Long(0,0)
	a(1) = fx.Colors.To32Bit(colorsMap.GetDefault(s.ToLowerCase,fx.Colors.From32Bit(0)))
	If a(1) <> 0 Then
		a(0) = 1
	Else
		Dim mtch As Matcher = Regex.Matcher2(rex,Regex.CASE_INSENSITIVE,s)
		If mtch.find Then
			a(0) = 1
			If mtch.GetEnd(1) = 2 Then 	' there is ExColor (ex.: F7Red)
				a(1) = fx.Colors.To32Bit(colorsMap.GetDefault( mtch.Group(2).ToLowerCase,fx.Colors.From32Bit(0)))
				If a(1) = 0 Then
					a(0) = 0
				Else
					a(1) = Bit.OrLong(Bit.AndLong(0x00FFFFFF,a(1)),Bit.ShiftLeftLong(Bit.ParseLong(mtch.Group(1),16),24))
				End If
			Else
				If s.Length = 3 Then s = Regex.Replace2("[\dABCDEF]",Regex.CASE_INSENSITIVE, s, "$0F")
				s = "FF000000".SubString2(0,8-s.Length) & s
				Dim jo As JavaObject
				a(1) = jo.InitializeStatic("java.lang.Long").RunMethod("parseLong", Array(s, 16))
			End If
		End If
	End If
	Return a
End Sub
Sub shadow(panel As Pane,w As Int,h As Int) As Pane
	Dim shadowwidth As Int = 10
	Dim canv As B4XCanvas
	Dim rect As B4XRect
	canv.Initialize(panel)
	rect.Initialize(w-shadowwidth,0,w,h)
	canv.DrawRect(rect,0X0F000000,True,1)
	rect.Initialize(shadowwidth,h-shadowwidth,w-shadowwidth,h)
	canv.DrawRect(rect,0X0F000000,True,1)
	rect.Initialize(w-shadowwidth,0,w,shadowwidth)
	canv.DrawRect(rect,0X00000000,True,1)
	rect.Initialize(0,h-shadowwidth,shadowwidth,h)
	canv.DrawRect(rect,0X00000000,True,1)
	Return panel
End Sub
Sub setBackground(f() As String,panel As Pane)
	Dim groundColor As String = IIf(f(1) = "","FFC0C0C0",f(1))
	Dim prms() As String = Regex.split("[ ]+",groundColor)
	If prms.Length = 1 Then
		CSSUtils.SetStyleProperty(panel,"-fx-background-color", CSSUtils.ColorToHex(decodeColor(prms(0))))
	else If prms.Length > 1 Then
		Dim bckgColor As String = "linear-gradient("
		If prms.Length > 2 Then bckgColor = bckgColor & "to " & implodeFrom(" ",prms,2,3) & ","
		bckgColor = bckgColor & CSSUtils.ColorToHex(decodeColor(prms(0))) & "," & CSSUtils.ColorToHex(decodeColor(prms(1))) & ")"
		CSSUtils.SetStyleProperty(panel, "-fx-background-color",bckgColor)
	End If
End Sub
Sub setTipefaces( parms As String) As Map
	Dim m As Map = CreateMap("TextSize":12,"TextColor":fx.Colors.Black,"Gravity": "CENTER_LEFT")
	m.Put("Typeface",fx.DefaultFont(12))
	If parms <> "" Then
		Dim s() As String = Regex.Split("\s+",parms)
		For i = 0 To s.Length - 1
			Select s(i).ToLowerCase
				Case "fa", "fontawesome"
					m.Put("Typeface", fx.CreateFontAwesome(m.Get("TextSize")))
				Case "mi", "materialicons"
					m.Put("Typeface", fx.CreateMaterialIcons(m.Get("TextSize")))
				Case "left"
					m.Put("Gravity", "CENTER_LEFT")
				Case "right"
					m.Put("Gravity","CENTER_RIGHT")
				Case "center"
					m.Put("Gravity", "CENTER")
				Case Else
					If IsNumber(s(i)) Then
						m.Put("TextSize",s(i))
						m.Put("Typeface",fx.DefaultFont(s(i)))
					Else
						Dim a() As Long = isColor(s(i))
'						If Regex.ismatch(reHexaDecimal,s(i)) Or colorsMap.ContainsKey(s(i).ToLowerCase) Then
						If a(0) = 1 Then m.Put("TextColor",fx.Colors.From32Bit(a(1)))
						End If
			End Select
		Next
	End If
	Return m
End Sub
Private Sub addButton(Caption As String,Name As String,x As Int,y As Int) As Button
	Dim btnx As Button
	btnx.initialize(Name)
	btnx.TextSize = 12
	btnx.Text = Caption
	fh_panel.AddNode(btnx,x,y,Caption.Length*10,28)
	Return btnx
End Sub
private Sub setEraser(f() As String) As Label
	Dim l As Label
	l.Initialize("Eraser")
	l.Text = Chr(10008)	' cancel sign
	l.Tag = f(1)
	l.TextColor = fx.Colors.ARGB(79,0,0,0)
	l.MouseCursor = fx.Cursors.HAND
	CSSUtils.SetStyleProperty(l, "-fx-font-size", "14")
	Return l
End Sub
private Sub setTextArea(f() As String) As TextArea
	Dim t As TextArea
	t.Initialize("areaTxt")
	t.Tag = f(1)
	t.WrapText = True
	Return t
End Sub
private Sub setText(f() As String) As TextField
	Dim t As TextField
	If f(0) = "P" Then
		t.InitializePassword("txt")
	Else
		t.Initialize("txt")
	End If
	If f(6) <> "" Then t.TooltipText = f(6)
	t.Tag = f(1)
	CSSUtils.SetStyleProperty(t, "-fx-font-size", "12")
	CSSUtils.SetStyleProperty(t, "-fx-text-fill","black")
	CSSUtils.SetStyleProperty(t, "-fx-padding","2")
	Return t
End Sub
Sub createMenu(menuParms As String) As MenuBar
	Dim menu As Menu
	Dim menubar As MenuBar
	Dim widgets() As String = Regex.Split(";\s*",menuParms)
	menubar.Initialize("")
	Dim key As String = ""
	For iw = 0 To widgets.Length - 1
		field = Regex.Split(",", widgets(iw) & ",,,,,,*")
		field(field.Length-1) = ""	' remove *
		If field(0) <> key Then
			key = field(0)
			menu.Initialize(key,"")
			menubar.Menus.Add(menu)
		End If
		Dim x As MenuItem
		x.Initialize(field(1),"Menu")		
		x.Tag = (field(2))	' menu linked sub
		menu.MenuItems.Add(x)
	Next
	Return menubar
End Sub
Sub Eraser_MouseClicked(EventData As MouseEvent)
	Dim l As Label = Sender
	setValue(l.Tag,Defaults.GetDefault(l.Tag,""))
End Sub
Sub Menu_Action
	Dim mi As MenuItem = Sender
	Dim dt() As String = Regex.Split("\.", mi.tag)
	If dt.Length = 1 Then CallSub("Main",mi.tag)
	If dt.Length = 2 Then CallSub(dt(0),dt(1))
End Sub
Sub CopyObject(Obj As Object) As Object
	Dim raf As RandomAccessFile
	raf.Initialize(File.Dirtemp, "1.dat", False)
	raf.WriteObject(Obj, True, 0)
	Dim newObj As Object
	newObj = raf.ReadObject(0)
	raf.Close
	Return newObj
End Sub
Private Sub CreateButton(Name As String, caption As String, event As String,nodeType As String) As Button
	Dim btnx As Button
	btnx.Initialize(event)
	If isGraphicFile(caption) Then  ' grafic button
		Dim bmp As B4XBitmap = fx.LoadImage(File.DirAssets, caption)
		Dim jo As JavaObject = btnx
		Dim iv As ImageView
		iv.Initialize("")
		iv.SetImage(bmp.Resize(24,24,True))
		jo.RunMethod("setGraphic", Array(iv))
		btnx.Tag = "24x24" ' tag whit picture dimension
	Else		
		Dim f() As String = Elem.Getdefault(Name,Array As String("","","","","","",""))
		CSSUtils.SetStyleProperty(btnx,"-fx-padding","0")
		Dim mp As Map = setTipefaces(IIf(nodeType="TB",f(7),f(6)))	' my be font awesome
		btnx.TextColor = mp.Get("TextColor")
		btnx.TextSize = mp.Get("TextSize")
		btnx.Font = mp.Get("Typeface")
		btnx.Text = caption
		btnx.Tag = Name
	End If
	widgetRef.Put(Name,Array As Object (btnx,nodeType,0,event,0,0))
	btnx.MouseCursor = fx.cursors.Hand
	Return btnx
End Sub
Sub isGraphicFile(f As String) As Boolean
	Return Regex.IsMatch2($".+(.png|.gif|.jpg)$"$,Regex.CASE_INSENSITIVE,f)
End Sub
Sub Createlabel(txt As String,Size As Int, event As String) As Label
	Dim lbl As Label
	lbl.Initialize(event)
	lbl.TextSize = Size
'	lbl.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.LEFT)
	lbl.Text = txt
	Return lbl
End Sub
Sub createImage(fileImage As String) As B4XView
	Dim xui As XUI
	Dim img As B4XBitmap = xui.LoadBitmap(File.GetFileParent(fileImage), File.GetName(fileImage))
	Dim c As B4XCanvas
	Dim xview As B4XView = xui.CreatePanel("")
	xview.SetLayoutAnimated(0, 0, 0, img.Width, img.Height)
	c.Initialize(xview)
	c.DrawBitmap(img,c.TargetRect)
	Return xview
End Sub
Sub createPanelButtons(pnlButtons As Pane) As Int
	If Section > 0 Then
		allButtons.Put("fh_Back",Array As Object("<--","Buttons","",0,btnWidth))
	End If
	If Not(allButtons.ContainsKey("Cancel")) Then allButtons.put("Cancel",Array As Object(translate("Cancel"),"Cancel","",0,btnWidth,""))
	If lonely > 1 Or Sections.Length > 1 Then
		If Not(allButtons.ContainsKey("Reset")) And Not(lonely Mod 97  = 0) Then allButtons.put("Reset",Array As Object(translate("Reset"),"Reset","",0,btnWidth,""))
		If Not(customOkButton) Then
			If Not(allButtons.ContainsKey("Ok")) And Not(lonely Mod 97 = 0) Then allButtons.put("Ok",Array As Object(translate("Ok"),"Buttons","",0,btnWidth,""))
		End If
	End If
	If Sections.Length > 1  Then
		If Section < Sections.Length -1 Then
			allButtons.put("fh_Forward",Array As Object("-->","Buttons","",0,btnWidth))
		End If
		If Section <> Sections.Length - 1 Then allButtons.Remove("Ok")
	End If
	Dim buttonTotalWidth As Int = 0	' total button width
	For Each Name As String In allButtons.Keys		
		Dim k() As Object = allButtons.Get(Name)
		If isGraphicFile(k(0)) Then
			Dim gBtn As Button = CreateButton(Name,k(0),k(1),"B")
			Dim wh() As String = Regex.Split("x",gBtn.Tag)
			gBtn.Tag = Name
			If after.ContainsKey(Name) Then
'				Dim afterNode As Node = getFromNodeMap(after.Get(Name),0)
'				fh_panel.AddNode(gBtn,afterNode.Left+afterNode.PrefWidth+5,afterNode.Top,k(4),btnHeight)
'				setInMap(Name,5,afterNode.Left+afterNode.PrefWidth+5+k(4))	' right position
			Else
				pnlButtons.AddNode(gBtn,buttonTotalWidth,5dip, wh(0)+10,wh(1)+10)
				buttonTotalWidth = buttonTotalWidth + wh(0)+20dip
			End If			
			k(3) = gBtn
		Else
			Dim btn As Button = CreateButton(Name,k(0),k(1),"B")
			If after.ContainsKey(Name) Then
			Else
				pnlButtons.AddNode(btn, buttonTotalWidth,0,k(4), btnHeight)
				buttonTotalWidth = buttonTotalWidth + k(4) + 1
			End If
			k(3) = btn
		End If
		allButtons.Put(Name,k)
	Next
	Return  buttonTotalWidth
End Sub
Sub createSlider(f() As String, handle As String) As Slider
	Dim wdgType As String = f(0)
	Dim Minimum,Maximum,Delta As Float
	If f(5) = "" Then f(5) = IIf(wdgType = "S","0 100","lack|of|data")	' default slide
	If wdgType = "S" Or wdgType = "TIME" Then
		Dim aSlider(3) As Float = Array As Float (0,0,0)
		Dim mtchCount As Int = 0
		Dim mtch As Matcher = Regex.Matcher("-?\d+", f(5))
		Do While mtch.Find
			aSlider(mtchCount) = mtch.Match
			mtchCount = mtchCount + 1
		Loop
		If mtchCount = 1 Then aSlider(1) = 100
		Minimum = Min(aSlider(0),aSlider(1))
		Maximum = Max(aSlider(0),aSlider(1))
		Delta = Abs(aSlider(0) - aSlider(1))
		If mtchCount = 3 Then	' number of decimal imposed
			Limits.Put(field(1) & "Decimals",aSlider(2))
		Else
			Dim dec As Int = Floor(Logarithm(Abs(aSlider(0) - aSlider(1)),10))
			Limits.Put(field(1) & "Decimals",IIf(dec <3, -dec+2,0))
		End If
	else if wdgType = "QS" Then
		Private listQS As List = splitKeyValue(field(1),field(5))
		Limits.Put(field(1),listQS)
		Minimum = 0
		Maximum = listQS.Size
		Delta = listQS.Size
	End If
	Dim align As String = "center"
	If wdgType = "S" Then align = align & "-right"
	Dim sldProto As Slider
	sldProto.Initialize(handle)
	sldProto.Tag = f(1)	' widget name
	sldProto.MinValue = Minimum
	sldProto.maxValue = Maximum
	Return sldProto
End Sub
Sub translate(w As String) As String
	Return Dictionary.GetDefault(w,w)
End Sub
Sub hide(Form As Form)
	Dim mf As JavaObject = Form.RootPane
	mf.RunMethodJO("getScene",Null).RunMethodJO("getWindow",Null).RunMethod("hide",Null)
End Sub
Sub show(Form As Form)
	Dim mf As JavaObject = Form.RootPane
	mf.RunMethodJO("getScene",Null).RunMethodJO("getWindow",Null).RunMethod("show",Null)
End Sub
Sub viewType(Name As String) As String
	Return fh_FieldsType.get(Name)
End Sub
Sub getLabelWidth(t As String,fontSize As Int) As Int
	Dim r As B4XRect = measureText(t, fontSize)
	Return r.Width
End Sub
Sub measureText(s As String, fontSize As Int) As B4XRect
	Dim cnv As B4XCanvas
'	Dim pnl As Pane
'	pnl.Initialize("")
'	cnv.Initialize(pnl)
	Dim font As B4XFont = fx.CreateFont("Default",fontSize,False,False)
	Dim r As B4XRect = cnv.MeasureText(s, font)
	Return r
End Sub
Sub extractParm(Key As String,data As String) As String
	' \s*border(?:\s*=\s*|\s+)(.+)
	Dim pattern As String = $"\s*${Key}(?:\s*=\s*|\s+)(.+)"$
	Dim Mtch As Matcher = Regex.Matcher2(pattern,Regex.CASE_INSENSITIVE, data)
	Do While Mtch.Find
		Return Mtch.Group(1)
	Loop
End Sub
Sub containsParm(Key As String,data As String) As Boolean
	Dim mtch As Matcher = Regex.Matcher2(Key,Regex.CASE_INSENSITIVE,data)
	Return mtch.Find
End Sub
#If JAVA
//Private nativeMe As JavaObject
//   nativeMe.InitializeContext
//  log(nativeMe.RunMethod("FirstMethod", Null))
public String FirstMethod() {
   return "Hello World!";
}
#End If